
/*
 * Primeiro exerccio do Tutorial de J2ME
 *
 * @author Tarcisio Camara
 */
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

/**
 * Classe que representa a bala do heri
 */
public class Fire extends Sprite {

    /**
     * Construtor
     * @param x, Posio x inicial
     * @param y, Posio y inicial
     * @param image Imagens que representam a bala
     *
     */
    public Fire(int x, int y, boolean v, Image[] image) {

        super(x, y, image);
        super.setXspeed(0);
        super.setYspeed(5);
        super.setVisible(v);
    }

    /**
     * Constructor Fire
     *
     * @param x, Posio x inicial
     * @param y, Posio y inicial
     * @param v, Se est visvel ou no
     * @param image Imagens que representam a bala
     * @param xspeed, Velocidade vertical da bala
     * @param yspeed, Velocidade horizontal da bala
     *
     */
    public Fire(int x, int y, boolean v, Image[] image, int xspeed,
                int yspeed) {

        super(x, y, image);
        super.setXspeed(xspeed);
        super.setYspeed(yspeed);
        super.setVisible(v);
    }

    /**
     * Renderiza a bala na tela
     */
    public void draw(Graphics g) {
        g.drawImage(getImage()[0], this.getX(), this.getY(), g.TOP | g.LEFT);
    }

    /**
     * Atualiza a posio da bala
     */
    public void update() {

        if(super.isVisible()) {
            // se saiu da tela, fica invisivel
            if((getY() < -this.getHeight())
                || (getY() > Constants.HEIGHT)) {
                super.setVisible(false);
            }

            // atualiza posio de acordo com velocidades
            super.setY(getY() - getYspeed());
            super.setX(getX() - getXspeed());
        }
    }
}
